function KeepieUppie:SceneTest()
--[[ THIS TEST IS DONE AUTOMATICALLY BY THE GAME NOW; IT SCANS THE SCRIPT FOR ANY MENTIONS OF "GetArea" AND TESTS THE SCENES FOR HAVING THOSE USED AREAS DEFINED!
	-- See if the required areas are present in the test scene
	if not (TestScene:HasArea("LZ Team 1") and TestScene:HasArea("LZ Team 2")) then
		-- If the test scene failed the compatibility test, invalidate it
		TestScene = nil;
	end
--]]
end

function KeepieUppie:StartActivity()
	print("START! -- KeepieUppie:StartActivity()!");
	
	--[[
		self:AddOverridePurchase(CreateACRocket("Nuclear Warhead"), Activity.PLAYER_1);
	--]]
	self:AddOverridePurchase(CreateACRocket("Nuclear Warhead","MDC.rte"), Activity.PLAYER_1);
	self:SetViewState(Activity.LZSELECT, Activity.PLAYER_1);
	
	self.WList = { "Grenade Launcher", "Blaster", "Nailgun", "Pistol", "Sniper Rifle", "Heavy Sniper Rifle", "Gatling Gun", "Flamer", "Napalm Flamer", "Spike Launcher", "Flak Cannon", "Auto Pistol", "Shotgun", "Auto Shotgun", "Mauler Shotgun", "Bazooka", "YAK47", "YAK4700", "TommyGun", "Uzi", "M16", "Shortgun", "Spaz12", "Spaz1200", "Rifle Long", "Desert Eagle", "Glock", "HAK 20", "Luger", "Peacemaker", "Lady Pistol" };
	self.AList = { "Mia", "Dafred", "Dimitri", "Gordon", "Brutus", "Sandra", "Soldier Light", "Soldier Heavy", "Browncoat Light", "Browncoat Heavy" };
	self.ESpawnTimer = Timer();
	self.LZ = SceneMan.Scene:GetArea("LZ Team 1");
	self.EnemyLZ = SceneMan.Scene:GetArea("LZ All");

	self.SurvivalTimer = Timer();
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.TimeLimit = 25000;
		self.timeDisplay = "twenty seconds";
		self.BaseSpawnTime = 6000;
		self.RandomSpawnTime = 8000;
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.TimeLimit = 45000;
		self.timeDisplay = "forty seconds";
		self.BaseSpawnTime = 5500;
		self.RandomSpawnTime = 7000;
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.TimeLimit = 65000;
		self.timeDisplay = "one minute";
		self.BaseSpawnTime = 5000;
		self.RandomSpawnTime = 6000;
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.TimeLimit = 95000;
		self.timeDisplay = "one minute and thirty seconds";
		self.BaseSpawnTime = 4500;
		self.RandomSpawnTime = 5000;
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.TimeLimit = 125000;
		self.timeDisplay = "two minutes and thirty seconds";
		self.BaseSpawnTime = 4000;
		self.RandomSpawnTime = 4500;
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.TimeLimit = 305000;
		self.timeDisplay = "five minutes";
		self.BaseSpawnTime = 3500;
		self.RandomSpawnTime = 4000;
	end
	
	self:SetTeamFunds(0, Activity.TEAM_1);

	self.StartTimer = Timer();
	self.started = false;
	
	self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
end

function KeepieUppie:PauseActivity(pause)
    	print("PAUSE! -- KeepieUppie:PauseActivity()!");
end

function KeepieUppie:EndActivity()
    	print("END! -- KeepieUppie:EndActivity()!");
		
end

function KeepieUppie:UpdateActivity()
	self:ClearObjectivePoints();

	if self.started then
		if self.ActivityState ~= Activity.OVER and self.ActivityState ~= Activity.EDITING then
			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				if self:PlayerActive(player) and self:PlayerHuman(player) then
					--Display messages.
					if self.StartTimer:IsPastSimMS(3000) then
						FrameMan:SetScreenText(math.floor(self.SurvivalTimer:LeftTillSimMS(self.TimeLimit) / 1000) .. " seconds left", player, 0, 1000, false);
					else
						FrameMan:SetScreenText("Keep the rocket alive for " .. self.timeDisplay .. "!", player, 333, 5000, true);
					end
				
					-- The current player's team
					local team = self:GetTeamOfPlayer(player);
					-- Check if any player's brain is dead
					if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
						self:SetPlayerBrain(nil, player);
						self:ResetMessageTimer(player);
						FrameMan:ClearScreenText(player);
						FrameMan:SetScreenText("Your rocket has been destroyed!", player, 333, -1, false);
						-- Now see if all brains of self player's team are dead, and if so, end the game
						if not MovableMan:GetClosestBrainActor(team) then
							self.WinnerTeam = self:OtherTeam(team);
							ActivityMan:EndActivity();
						end
					end
					
					--Check if the player has won.
					if self.SurvivalTimer:IsPastSimMS(self.TimeLimit) then
						self:ResetMessageTimer(player);
						FrameMan:ClearScreenText(player);
						FrameMan:SetScreenText("You survived!", player, 333, -1, false);
						
						self.WinnerTeam = Activity.TEAM_1;
						
						--Kill all enemies.
						for actor in MovableMan.Actors do
							if actor.Team ~= self.WinnerTeam then
								actor.Health = 0;
							end
						end

						ActivityMan:EndActivity();
					end
				end
			end

			--Spawn the AI.
			if self.ESpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
				local actor = {};
				for x = 0, math.ceil(math.random(3)) do
					local y = math.random();
					if y > 0.05 then
						actor[x] = CreateAHuman(self.AList[math.random(#self.AList)]);
						actor[x].Team = 1;
						actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
						actor[x]:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)]));
						actor[x]:AddInventoryItem(CreateHDFirearm("Medium Digger"));
					else
						actor[x] = CreateACrab("Dreadnought");
						actor[x].Team = 1;
						actor[x].AIMode = Actor.AIMODE_BRAINHUNT;
					end
				end
				local ship = nil;
				local z = math.random();
				if z > 0.90 then
					ship = CreateACRocket("Drop Crate","Dummy.rte");
				elseif z > 0.80 then
					ship = CreateACRocket("Rocklet","Dummy.rte");
				elseif z > 0.60 then
					ship = CreateACDropShip("Drop Ship","Dummy.rte");
				elseif z > 0.40 then
					ship = CreateACDropShip("Drop Ship MK1","Coalition.rte");
				elseif z > 0.20 then
					ship = CreateACRocket("Rocket MK2","Coalition.rte");
				else
					ship = CreateACRocket("Rocket MK1","Coalition.rte");
				end
				for n = 0, #actor do
					ship:AddInventoryItem(actor[n]);
				end
				ship.Team = 1;
				local w = math.random();
				if w > 0.5 then
					ship.Pos = Vector(self.EnemyLZ:GetRandomPoint().X,-50);
				else
					ship.Pos = Vector(self.LZ:GetRandomPoint().X,-50);
				end
				MovableMan:AddActor(ship);
				self.ESpawnTimer:Reset();
				self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime);
			end
		end
	else
		self.StartTimer:Reset();
		self.SurvivalTimer:Reset();
		
		FrameMan:SetScreenText("Order your rocket...", Activity.PLAYER_1, 0, 5000, false);
		
		--See if the rocket has spawned yet.
		for actor in MovableMan.Actors do
			if actor.ClassName == "ACRocket" and actor.Team == Activity.TEAM_1 then
				self:SetPlayerBrain(actor, Activity.PLAYER_1);
				self:SetObservationTarget(actor.Pos, Activity.PLAYER_1);
				self:SwitchToActor(actor, Activity.PLAYER_1, Activity.TEAM_1);
				
				self.started = true;
			end
		end
	end
	
	self:SetTeamFunds(0, Activity.TEAM_1);
	
	self:YSortObjectivePoints();
end